/* All Rights reserved */

#include <AppKit/AppKit.h>
#include "MILienzo.h"

@implementation MILienzo

- (void) prefPanel: (id)sender
{
   if(panel == nil)
   {
     [NSBundle loadNibNamed: @"Pref.gorm" owner: self] ;
     [panel makeKeyAndOrderFront: self] ;
   }
   else
   {
     [panel makeKeyAndOrderFront: self] ;
   }
}

- (void) selectFigura: (id)sender
{
  /* insert your code here */
  vboton = [sender tag] ;
}

- (void)mouseDown: (NSEvent *) evento
{
    locA = [self convertPoint:[evento locationInWindow] fromView:nil];
    BOOL clic = YES;

    while (clic)
      {
       evento = [[self window] nextEventMatchingMask: NSLeftMouseUpMask | NSLeftMouseDraggedMask];
    
      switch ([evento type])
         {
          case NSLeftMouseDragged:
            {
               locB = [self convertPoint:[evento locationInWindow] fromView:nil];
               NSSize dimensiones =  NSMakeSize(locB.x - locA.x, locB.y - locA.y) ;
               rectSeleccionado.origin = locA ;
               rectSeleccionado.size = dimensiones;
               seleccion = YES;
            
                 [self setNeedsDisplay: YES] ;
            }
             break;

          case NSLeftMouseUp:
            {
               clic = NO;
               NSMutableArray *figura = [NSMutableArray array] ;
               [figura addObject: [NSNumber numberWithInt: vboton]] ;
               [figura addObject: [NSNumber numberWithFloat: locA.x]] ;
               [figura addObject: [NSNumber numberWithFloat: locA.y]] ;               
               [figura addObject: [NSNumber numberWithFloat: locB.x]] ;
               [figura addObject: [NSNumber numberWithFloat: locB.y]] ;               
               [figura addObject: [color color]] ;
               [dibujos addObject: figura] ;
            }
             break;

         }
      }
}


- (void)drawRect: (NSRect) rect
{
   if([dibujos count] > 0)
   {
     id objeto ;
     NSBezierPath *esq ;
     NSEnumerator *dibujar = [dibujos objectEnumerator] ;
        
     while((objeto = [dibujar nextObject]))
        {
           NSPoint locAV = NSMakePoint([[objeto objectAtIndex: 1] floatValue], [[objeto objectAtIndex: 2] floatValue]) ;
           NSPoint locBV = NSMakePoint([[objeto objectAtIndex: 3] floatValue], [[objeto objectAtIndex: 4] floatValue]) ;            [[objeto objectAtIndex: 5] set] ;
            
           switch([[objeto objectAtIndex: 0] intValue])
           {
             case 1:
                 {
                   esq = [NSBezierPath bezierPath] ;
                   [esq moveToPoint: locAV] ; 
                   [esq lineToPoint: locBV] ;
                   [esq stroke] ; 
                 }
                 break;
             case 2:
                 {
                   esq = [NSBezierPath bezierPathWithOvalInRect: NSMakeRect(locAV.x, locAV.y, locBV.x - locAV.x, locBV.y - locAV.y)] ;
                   [esq fill] ; 
                 }
                 break;
             case 3:
                 {
                   esq = [NSBezierPath bezierPathWithRect: NSMakeRect(locAV.x, locAV.y, locBV.x - locAV.x, locBV.y - locAV.y)] ;
                   [esq fill] ;                  
                 }
                 break;        
           }
        }
   }

   if (seleccion)
      {
         [[color color] set] ;

         switch(vboton)   
         {
         case 1:
            {
            ruta = [NSBezierPath bezierPath] ;
            [ruta moveToPoint: locA] ; 
            [ruta lineToPoint: locB] ;
            [ruta stroke] ; 
            }
            break ;

        case 2:
            {    
            ruta = [NSBezierPath bezierPathWithOvalInRect: rectSeleccionado] ;
            [ruta fill] ; 
            }
            break ;
       case 3:
            {
            ruta = [NSBezierPath bezierPathWithRect: rectSeleccionado] ;
            [ruta fill] ;
            }
            break ;

      }

      }
}

- (BOOL) acceptsFirstMouse: (NSEvent*)theEvent
{
return YES ;  
}

-(void) awakeFromNib
{
vboton = 1 ;
dibujos = [NSMutableArray new] ;
}

- (void) dealloc
{
RELEASE(dibujos) ;
[super dealloc] ;
}

@end
